/**
 * To display the about dialog.
 */

//package org.apache.batik.apps.svgviewer;

import org.apache.batik.refimpl.util.JSVGCanvas;
import org.apache.batik.util.gui.resource.ButtonFactory;
import org.apache.batik.util.DocumentListener;
import org.apache.batik.util.DocumentEvent;
import org.apache.batik.util.DocumentLoadingEvent;
import org.apache.batik.util.DocumentLoadRunnable;
import org.apache.batik.dom.svg.DefaultSVGContext;
import org.apache.batik.dom.svg.SVGOMDocument;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.util.gui.resource.ResourceManager;
import org.apache.batik.dom.svg.SVGDocumentFactory;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;

import java.awt.event.ActionEvent;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.FlowLayout;

import java.util.ResourceBundle;

public class AboutAction extends AbstractAction implements DocumentListener {
    ViewerFrame vf;
    JSVGCanvas canvas;
    protected static JFrame aboutFrame;
    ResourceManager resources;
    ResourceBundle bundle;
    SVGDocumentFactory df;

    public AboutAction() {}
    public AboutAction(ViewerFrame vf) {
	this.vf=vf;
	canvas=vf.getJSVGCanvas();
	resources=vf.getResources();
	bundle=vf.getBundle();
	df=vf.getDocFactory();
    }
    public void actionPerformed(ActionEvent e) {
	if (aboutFrame == null) {
	    aboutFrame = new JFrame(resources.getString("About.title"));
	    aboutFrame.setSize(resources.getInteger("About.width"),
			       resources.getInteger("About.height"));
	    JPanel panel = new JPanel(new BorderLayout());
	    
	    aboutFrame.getContentPane().add(panel);
	    panel.setBorder(BorderFactory.createCompoundBorder
			    (BorderFactory.createTitledBorder
			     (BorderFactory.createEtchedBorder(),
			      resources.getString("About.border_title"),
			      TitledBorder.CENTER,
			      TitledBorder.DEFAULT_POSITION),
			     BorderFactory.createEmptyBorder(5, 5, 5, 5)));
	    
	    JPanel p = new JPanel(new FlowLayout(FlowLayout.RIGHT));
	    ButtonFactory bf = new ButtonFactory(bundle, null);
	    JButton button;
	    p.add(button = bf.createJButton("AboutCloseButton"));
	    button.addActionListener(new AbstractAction() {
		    public void actionPerformed(ActionEvent e) {
			aboutFrame.setVisible(false);
		    }
		});
	    aboutFrame.getContentPane().add("South", p);
	    canvas = new JSVGCanvas(vf);
	    canvas.setBorder(BorderFactory.createLoweredBevelBorder());
	    panel.add(canvas);
	    
	    String uri =
		getClass().getResource("resources/authors.svg").toString();
	    Thread t = DocumentLoadRunnable.createLoaderThread(uri,
							       this,
							       df);
	    
	    t.start();
	}
	Rectangle fr = vf.getBounds();
	Dimension sd = aboutFrame.getSize();
	aboutFrame.setLocation(fr.x + (fr.width  - sd.width) / 2,
			       fr.y + (fr.height - sd.height) / 2);
	aboutFrame.show();
    }
    /**
     * Take action on receipt of a DocumentEvent.
     */
    public void processDocumentEvent(DocumentEvent e) {
	if (e.classid == DocumentEvent.LOADING) {
	    if (e.type == DocumentLoadingEvent.DONE) {
		DefaultSVGContext dc = new DefaultSVGContext();
		SVGOMDocument doc = (SVGOMDocument)e.getValue();
		dc.setUserAgent(vf);
		doc.setSVGContext(dc);
		canvas.setSVGDocument(doc);
	    }
	} else if (e.classid == DocumentEvent.PROPERTY) {
	    //
	}
    }   
}
