/**
 * To manage the actions associated with the application.
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.Action;
import org.w3c.dom.svg.SVGAElement;
import org.apache.batik.dom.svg.SVGOMDocument;
//import org.apache.batik.apps.svgviewer.ViewerFrame;

public interface Application {
    /**
     * Called when a new viewer frame needs to be created.
     */
    void createAndShowViewerFrame();
    
    /**
     * Creates a close action.
     */
    Action createCloseAction(ViewerFrame vf);
    
    /**
     * Creates a exit action.
     */
    Action createExitAction();
    
    /**
     * Returns the XML parser class name.
     */
    String getXMLParserClassName();
    
    /**
     * Called when the frame will be closed.
     * @return true if the frame must be closed.
     */
    boolean closeFrame(ViewerFrame f);
    
    /**
     * Opens the given link.
     */
    void openLink(ViewerFrame f, SVGAElement elt);
    
    /**
     * Return the SVGOMDocument instance. 
     */
    public SVGOMDocument getSVGOMDocument();

    /**
     * Set the SVGOMDocument instance. 
     */
    public void setSVGOMDocument(SVGOMDocument doc);
    
    /**
     * Get reference to the ViewerFrame.
     */
    public ViewerFrame getViewerFrame();

}





