/*****************************************************************************
 * Copyright (C) The Apache Software Foundation. All rights reserved.        *
 * ------------------------------------------------------------------------- *
 * This software is published under the terms of the Apache Software License *
 * version 1.1, a copy of which has been included with this distribution in  *
 * the LICENSE file.                                                         *
 *****************************************************************************/

/**============================================================
 * A FileFilter for data files, based on SVGFileFilter from
 * xml-apache.
 *
 * @author Marlon Pierce
 *============================================================*/

import java.io.File;
import javax.swing.filechooser.FileFilter;

public class DataFileFilter extends FileFilter {
    /**
     * Returns true if <tt>f</tt> has the .dat extension.
     */
    public boolean accept(File f) {
        boolean accept = false;
        String fileName = null;
        if (f != null) {
            if (f.isDirectory()) {
                accept = true;
            } else {
                fileName = f.getPath().toLowerCase();
                if (fileName.endsWith(".dat"))
                    accept = true;
            }
        }
        return accept;
    }

    /**
     * Returns the file description
     */
    public String getDescription() {
        return ".dat";
    }
}
