/**
 * To display the description of the document
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.AbstractAction;
import javax.swing.JTextArea;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

import java.awt.event.ActionEvent;
import java.awt.Color;
import java.awt.Font;

import org.apache.batik.util.gui.resource.ResourceManager;

public class DescriptionAction extends AbstractAction {
    //desc is the document description
    //uri is the URI of the current document
    protected String description,uri;
    protected ViewerFrame vf;
    protected ResourceManager resources;

    public DescriptionAction() {}
    
    public DescriptionAction(ViewerFrame vf){
	this.vf=vf;
	description=vf.getDescription();
	uri=vf.getUri();
	resources=vf.getResources();
    }
    public void actionPerformed(ActionEvent e) {
	if (description == null) {
	    return;
            }
	JFrame    fr  = new JFrame(uri);
	fr.setSize(resources.getInteger("Description.width"),
		   resources.getInteger("Description.height"));
	JTextArea ta  = new JTextArea();
	ta.setLineWrap(true);
	ta.setBackground(Color.lightGray);
	ta.setFont(new Font("monospaced", Font.PLAIN, 10));
	
	JScrollPane scroll = new JScrollPane();
	scroll.getViewport().add(ta);
	scroll.setVerticalScrollBarPolicy
	    (JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	fr.getContentPane().add("Center", scroll);
	
	ta.setText(description);
	ta.setEditable(false);
	fr.show();
    }
}



