/**
 * To save the current document as JPG.
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.JFileChooser;
import javax.swing.AbstractAction;
import java.io.File;
import java.io.FileOutputStream;
import java.io.BufferedOutputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.lang.Thread;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.awt.event.ActionEvent;

import org.apache.batik.refimpl.transcoder.ImageTranscoder;
import org.apache.batik.refimpl.transcoder.JpegTranscoder;
import org.apache.batik.refimpl.util.JSVGCanvas;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
//import org.apache.batik.apps.svgviewer.StatusBar;
import org.apache.batik.util.gui.resource.ResourceManager;

public class ExportJPGAction extends AbstractAction {
    ViewerFrame vf;
    JSVGCanvas canvas;
    protected String currentExportPath;
    protected StatusBar statusBar;
    protected ResourceManager resources;

    public ExportJPGAction(ViewerFrame vf){
	this.vf=vf;
	canvas=vf.getJSVGCanvas();
	currentExportPath=vf.getCurrentExportPath();
	statusBar=vf.getStatusBar();
	resources=vf.getResources();
    }
    public void actionPerformed(ActionEvent e) {
	JFileChooser fileChooser =
	    new JFileChooser(currentExportPath);
            fileChooser.setFileHidingEnabled(false);
            fileChooser.setFileSelectionMode
                (JFileChooser.FILES_AND_DIRECTORIES);
	    
            int choice = fileChooser.showSaveDialog(vf);
            if (choice == JFileChooser.APPROVE_OPTION) {
                final File f = fileChooser.getSelectedFile();
                BufferedImage buffer = canvas.getBuffer();
                // create a BufferedImage of the appropriate type
                int w = buffer.getWidth();
                int h = buffer.getHeight();
                final ImageTranscoder trans = new JpegTranscoder();
                final BufferedImage img = trans.createImage(w, h);
                // paint the buffer to the image
                Graphics2D g2d = img.createGraphics();
                g2d.drawImage(buffer, null, 0, 0);
                new Thread() {
                    public void run() {
                        try {
                            currentExportPath = f.getCanonicalPath();
                            OutputStream ostream =
				new BufferedOutputStream(new FileOutputStream(f));
                            trans.writeImage(img, ostream);
                            ostream.flush();
                            ostream.close();
                            statusBar.setMessage(
						 resources.getString("Document.export"));
                        } catch (IOException ex) { }
                    }
		    }.start();
            }
    }
}

