/**
 * To manage the location bar action
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.AbstractAction;
import java.awt.event.ActionEvent;
import java.io.File;

import org.apache.batik.util.DocumentLoadRunnable;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.util.gui.LocationBar;
import org.apache.batik.dom.svg.SVGDocumentFactory;

public class LocationBarAction extends AbstractAction {
    ViewerFrame vf;
    String uri;
    LocationBar locationBar;
    SVGDocumentFactory df;

    public LocationBarAction() {}

    public LocationBarAction(ViewerFrame vf) {
	this.vf=vf;
	uri=vf.getUri();
	locationBar=vf.getLocationBar();
	df=vf.getDocFactory();
    }

    public void actionPerformed(ActionEvent e) {
	String s = locationBar.getText().trim();
	if (!s.equals("") && !s.equals(uri)) {
	    uri = s;
	    File f = new File(uri);
                if (f.exists()) {
                    if (f.isDirectory()) {
                        uri = null;
                    } else {
                        uri = "file:" + uri;
                    }
                }
                if (uri != null) {
                    locationBar.setText(uri);
                    locationBar.addToHistory(uri);
                    Thread t =
                      DocumentLoadRunnable.createLoaderThread(uri,
                                                              vf,
                                                              df);
                    vf.runThread(t);
                }
            }
        }
    }

