/**
 * To open a new document
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.JFileChooser;
import javax.swing.AbstractAction;
import java.io.File;
import java.io.IOException;
import java.awt.event.ActionEvent;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.util.SVGFileFilter;

public class OpenAction extends AbstractAction {

    ViewerFrame vf;
    String currentPath;

    public OpenAction() {}
    
    public OpenAction(ViewerFrame vf){
	this.vf=vf;
	currentPath=vf.getCurrentPath();
    }
    
    public void actionPerformed(ActionEvent e) {
	JFileChooser fileChooser =
	    new JFileChooser(currentPath);
	fileChooser.setFileHidingEnabled(false);
	fileChooser.setFileSelectionMode
	    (JFileChooser.FILES_AND_DIRECTORIES);
	fileChooser.setFileFilter(new SVGFileFilter());
	
	int choice = fileChooser.showOpenDialog(vf);
	if (choice == JFileChooser.APPROVE_OPTION) {
	    File f = fileChooser.getSelectedFile();
	    try {
		vf.loadDocument(currentPath = f.getCanonicalPath());
	    } 
	    catch (IOException ex) {
	    }
	}
    }
}
