/**
 * To reload the current document
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.AbstractAction;
import javax.swing.JComponent;
import java.util.LinkedList;
import java.util.Iterator;
import java.awt.event.ActionEvent;
import org.apache.batik.util.DocumentLoadRunnable;
import org.apache.batik.dom.svg.SVGDocumentFactory;
import org.apache.batik.util.gui.resource.JComponentModifier;

public class ReloadAction extends    AbstractAction
    implements JComponentModifier {

    ViewerFrame vf;
    String uri;
    SVGDocumentFactory df;
    
    java.util.List components = new LinkedList();
    public ReloadAction() {}

    public ReloadAction(ViewerFrame vf) {
	this.vf=vf;
	uri=vf.getUri();
	df=vf.getDocFactory();
    }

    public void actionPerformed(ActionEvent e) {
	if (uri != null) {
	    Thread t =
		DocumentLoadRunnable.createLoaderThread(uri,
							vf,
							df);
	    vf.runThread(t);
            }
    }
    
    public void addJComponent(JComponent c) {
	components.add(c);
            c.setEnabled(true);
    }
    
    protected void update(boolean isLoadComplete) {
	Iterator it = components.iterator();
	while (it.hasNext()) {
                ((JComponent)it.next()).setEnabled(isLoadComplete);
	}
    }
}
