/**
 * To view the current document source.
 */

//package org.apache.batik.apps.svgviewer;

import org.apache.batik.util.gui.resource.JComponentModifier;
import javax.swing.AbstractAction;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;
import java.net.URL;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.IOException;
import java.util.zip.GZIPInputStream;
import java.util.Iterator;
import java.awt.event.ActionEvent;
import java.awt.Color;
import java.awt.Font;
import org.apache.batik.util.gui.resource.ResourceManager;

public class SourceAction extends AbstractAction {

    ViewerFrame vf;
    String uri;
    ResourceManager resources;
    char[] buffer;

    public SourceAction(ViewerFrame vf){
	this.vf=vf;
	uri=vf.getUri();
	resources=vf.getResources();
	buffer=vf.getBuffer();
    }
    
    public void actionPerformed(ActionEvent e) {
            if (uri == null) {
                return;
            }
            JFrame fr = new JFrame(uri);
            fr.setSize(resources.getInteger("Source.width"),
                       resources.getInteger("Source.height"));
            JTextArea ta  = new JTextArea();
            ta.setLineWrap(true);
            ta.setBackground(Color.lightGray);
            ta.setFont(new Font("monospaced", Font.PLAIN, 11));

            JScrollPane scroll = new JScrollPane();
            scroll.getViewport().add(ta);
            scroll.setVerticalScrollBarPolicy
                (JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
            fr.getContentPane().add("Center", scroll);

            Document  doc = new PlainDocument();
            try {
                URL    u  = new URL(uri);
                InputStream is = u.openStream();
                try {
                    is = new GZIPInputStream(is);
                } catch (IOException ex) {
                    is.close();
                    is = u.openStream();
                }
                Reader in = new InputStreamReader(is);
                int nch;
                while ((nch = in.read(buffer, 0, buffer.length)) != -1) {
                    doc.insertString(doc.getLength(),
                                     new String(buffer, 0, nch), null);
                }
            } catch (Exception ex) {
                // !!! TODO : dialog
                System.err.println(ex.toString());
            }

            ta.setDocument(doc);
            ta.setEditable(false);
            fr.show();
       }
    }

