/**
 * To display the thumbnail view of the document
 */

//package org.apache.batik.apps.svgviewer;

import javax.swing.AbstractAction;
import javax.swing.JFrame;
import javax.swing.ImageIcon;

import java.net.URL;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.event.ActionEvent;

import org.apache.batik.util.gui.resource.ResourceManager;
//import org.apache.batik.apps.svgviewer.ViewerFrame;
import org.apache.batik.refimpl.util.JSVGCanvas;

public class ThumbnailAction extends AbstractAction {
    ViewerFrame vf;
    ResourceManager resources;
    JFrame thumbnailFrame;
    JSVGCanvas canvas;
    
    public ThumbnailAction() {}

    public ThumbnailAction(ViewerFrame vf){
	this.vf=vf;
	resources=vf.getResources();
	thumbnailFrame=vf.getThumbnailFrame();
	canvas=vf.getJSVGCanvas();
    }

    public void actionPerformed(ActionEvent e) {
	if (thumbnailFrame == null) {
	    thumbnailFrame =
		new JFrame(resources.getString("Thumbnail.title"));
	    thumbnailFrame.setSize
		(resources.getInteger("Thumbnail.width"),
		 resources.getInteger("Thumbnail.height"));
	    
	    thumbnailFrame.getContentPane().add(canvas.getThumbnail());
	    
	    URL url =
		getClass().getResource(resources.getString("Frame.icon"));
	    thumbnailFrame.setIconImage(new ImageIcon(url).getImage());
	}
	Rectangle fr = vf.getBounds();
	Dimension td = thumbnailFrame.getSize();
	thumbnailFrame.setLocation(fr.x + (fr.width  - td.width) / 2,
				   fr.y + (fr.height - td.height) / 2);
	thumbnailFrame.show();
    }
}
